@*******************************
@* GBA Graphics Library        *
@*  by Jeff Frohwein, v1.0224  *
@* http://www.devrs.com        *
@*******************************

@ Draw an outline ellipse in GBA graphics modes 3 or 5 in ARM asm
@ Entry:  x = middle x coordinate
@         y = middle y coordinate
@        xr = radius width
@        yr = radius height
@     color = pixel color
@      addr = screen base addr
@ (void) gfxEllipse (u8 x, u8 y, u8 xr, u8 yr, u16 color, u32 addr);

        .ARM
        .ALIGN
        .GLOBL  gfxEllipse

@ r0 = point x
@ r1 = point y
@ r2 = color
@ r3 = ScrnBaseAddr
@ r4 = radius width
@ r5 = radius height
@ r6 = sin count
@ r7 = relX
@ r8 = relY
@ r9 = temp
@ r10 = temp
@ r11 = middle x
@ r12 = middle y

gfxEllipse:
        sub     sp,sp,#8
        stmfd   r13!,{r0-r12,r14}

        mov     r11,r0
        mov     r12,r1
        mov     r4,r2
        mov     r5,r3

        ldr     r2,[r13,#64]     @ r2 = color off stack
        ldr     r3,[r13,#68]     @ r2 = scrn base addr off stack

        mov     r6,#0
_circ0:
@ Draw top/bottom arcs
        mov     r6,r6,lsl #1
        mul     r9,r6,r4
        mov     r6,r6,lsr #1

        mov     r7,r9,lsr #8

        adr     r9,SinLUp
        ldrb    r9,[r9,r6]

        mul     r10,r9,r5

        mov     r8,r10,lsr #8

        add     r0,r11,r7
        add     r1,r12,r8
        bl      gfxPixel        @ Draw arc 270 to 315

        sub     r0,r11,r7
        bl      gfxPixel        @ Draw arc 270 to 225

        sub     r1,r12,r8
        bl      gfxPixel        @ Draw arc 90 to 135

        add     r0,r11,r7
        bl      gfxPixel        @ Draw arc 90 to 45

@ Draw top/bottom arcs
        mov     r6,r6,lsl #1
        mul     r9,r6,r5
        mov     r6,r6,lsr #1

        mov     r8,r9,lsr #8

        adr     r9,SinLUp
        ldrb    r9,[r9,r6]

        mul     r10,r9,r4

        mov     r7,r10,lsr #8

        add     r0,r11,r7
        add     r1,r12,r8
        bl      gfxPixel        @ Draw arc 360 to 315

        sub     r1,r12,r8
        bl      gfxPixel        @ Draw arc 0 to 45

        sub     r0,r11,r7
        bl      gfxPixel        @ Draw arc 180 to 135

        add     r1,r12,r8
        bl      gfxPixel        @ Draw arc 180 to 225

        add     r6,r6,#1
        cmp     r6,#91          @ Are we done yet?
        bne     _circ0          @ Not yet

        ldmfd   r13!,{r0-r12,r14}
        add     sp,sp,#8
        bx      r14

SinLUp:
        .byte   255,255,255,255,255,255,255,255
        .byte   255,255,255,254,254,254,254,254
        .byte   253,253,253,253,252,252,252,251
        .byte   251,250,250,250,249,249,248,248
        .byte   247,247,246,245,245,244,244,243
        .byte   242,242,241,240,240,239,238,237
        .byte   236,236,235,234,233,232,232,231
        .byte   230,229,228,227,226,225,223,222
        .byte   221,220,219,218,216,215,214,213
        .byte   211,210,208,207,205,204,202,201
        .byte   199,198,196,194,193,191,189,187
        .byte   185,183,182

